/*
 *	main.c
 *
 *	eǂ
 *
 *	* Thu Feb 16 21:19:58 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	
 ****************************************************************************/

static const short pat_pce[] = {
	SPR_PCE30,/* SPR_PCE31, SPR_PCE32, SPR_PCE33,*/
	SPR_PCE40,/* SPR_PCE41, SPR_PCE42, SPR_PCE43,*/
	SPR_PCE50,/* SPR_PCE51, SPR_PCE52, SPR_PCE53,*/
	SPR_PCE00,/* SPR_PCE01, SPR_PCE02, SPR_PCE03,*/
	SPR_PCE10,/* SPR_PCE11, SPR_PCE12, SPR_PCE13,*/
	SPR_PCE20,/* SPR_PCE21, SPR_PCE22, SPR_PCE23,*/
};

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	colors_sel = 6; /* 3`6 */
	level_sel = 1; /* 1`99 */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result;
	int x;
	int y;
	//
	int sel = 0;
	int title_y = 30;

	for(;;) {
		schedule();

		/* tF[hAEgisA܂́AB */
		if(title_y) {
			if(joy & (TRG_UP | TRG_DN | TRG_LF | TRG_RI | TRG_A | TRG_B | TRG_SELECT)) {
				joy &= ~(TRG_UP | TRG_DN | TRG_LF | TRG_RI | TRG_A | TRG_B | TRG_SELECT);
				title_y = 0;
			} else {
				title_y--;
			}
		}

		/* wi\B */
		bg_disp();

		/* ^Cg\B */
		x = 0;
		y = -title_y;
		sprite_draw(0, y, SPR_TITLE, 0);

		/* tF[hCB */
		if(title_y > 20) {
			brightness(0, 0, DISP_X - 1, DISP_Y - 1, 2);
			title_y--;
		} else if(title_y > 10) {
			brightness(0, 0, DISP_X - 1, DISP_Y - 1, 1);
			title_y--;
		} else if(title_y > 0) {
			title_y--;
		} else {

			/* X^[gHIH */
			if(joy & TRG_A) {
				result = 0;
				break;
			}
			if(joy & TRG_SELECT) {
				result = -1;
				break;
			}

			/* JnxAs[XFIB */
			if(joy & TRG_UP) {
				sel = 0;
			}
			if(joy & TRG_DN) {
				sel = 1;
			}
			if(!sel) {
				if((joy & TRG_LF) && (level_sel > 1)) {
					level_sel--;
				}
				if((joy & TRG_RI) && (level_sel < 99)) {
					level_sel++;
				}
			} else {
				if((joy & TRG_LF) && (colors_sel > 3)) {
					colors_sel--;
				}
				if((joy & TRG_RI) && (colors_sel < 6)) {
					colors_sel++;
				}
			}

			/* ǂ\B */
			x = 96;
			y = 32;
			render_string_framed(&render, x + 16, y, "", 0x80, 0x330);
			render_string_framed(&render, x +  8, y, "", 0x80, 0x330);
			render_string_framed(&render, x +  0, y, "", 0x80, 0x330);

			/* JnXe[WA΂̐F̕\B */
			x = (DISP_X - 4 * 12) / 2 - 1;
			y = 44;
			if(!sel) {
				if(level_sel == 1) {
					render_printf_framed(&render, x, y, 0x82, 2, "  LEVEL %2d >", level_sel);
				} else if(level_sel == 99) {
					render_printf_framed(&render, x, y, 0x82, 2, "< LEVEL %2d  ", level_sel);
				} else {
					render_printf_framed(&render, x, y, 0x82, 2, "< LEVEL %2d >", level_sel);
				}
			} else {
					render_printf_framed(&render, x, y, 0x82, 3, "  LEVEL %2d  ", level_sel);
			}
			//
			y += 8;
			if(sel) {
				if(colors_sel == 3) {
					render_printf_framed(&render, x, y, 0x82, 2, "  COLORS%2d >", colors_sel);
				} else if(colors_sel == 6) {
					render_printf_framed(&render, x, y, 0x82, 2, "< COLORS%2d  ", colors_sel);
				} else {
					render_printf_framed(&render, x, y, 0x82, 2, "< COLORS%2d >", colors_sel);
				}
			} else {
					render_printf_framed(&render, x, y, 0x82, 3, "  COLORS%2d  ", colors_sel);
			}

			/* vvg\B */
			if(now % SEC(1) < SEC(0.75)) {
				x = (DISP_X - 4 * 8) / 2 - 1;
				y = DISP_Y - 26;
				render_string_framed(&render, x, y, " A START", 0x82, 3);
				y += 8;
				render_string_framed(&render, x, y, "SEL EXIT", 0x82, 3);
			}
		}

		/* XRA\B */
		score_disp(1);
	}

	return result;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof game);

	game.seed = pceTimerGetCount();
	game.level = level_sel;

	/* tB[h[̃Z_W܂B */
	game.side[0].pos = get_field_pos(0);
	game.side[1].pos = get_field_pos(1);

	/* Jnɂ1sNZړ̂h߁B */
	game.side[0].ofs = fadd(game.side[0].ofs, fld(0.5));
	game.side[1].ofs = fsub(game.side[1].ofs, fld(0.5));

	/* ̈ʒu܂B */
	game.taco_row = FIELD_ROWS - 3;
	game.taco_pos = (game.side[0].pos + game.side[1].pos) / 2;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int go_disp = SEC(1); /* GO\ */
	int levelup_cnt = LEVELUP_CNT_1ST; /* xAbvɕKvȏŐ */
	//
	int x;
	int y;

	/* Q[܂B */
	game_init();

	/* JnOos܂B */
	game_ready();

	for(;;) {
		schedule();

		/* Ȁs܂B */
		awa_action();

		/* ̏s܂B */
		taco_action();

		/* tB[h̏s܂B */
		field_action(0);
		field_action(1);

		/* Eꂩ̃tB[hŏŊJnAA𑝂₵܂B */
		if(game.side[0].erase || game.side[1].erase) {
			game.chain++;

			/* A\JnB(2ÁA\̔ɂ薳܂B) */
			game.chain_val = game.chain;
			game.chain_cnt = 0;

			/* xAbvpŃJE^B(xŕgĂAƐ邱Ƃɂ܂) */
			game.erase_cnt++;

		/* EtB[hƂɈԂȂ΁AAZbg܂B */
		} else if(!game.side[0].active && !game.side[1].active) {
			game.chain = 0;
		}

		/* GAԂXV܂B */
		game.area_stat = get_area_stat();

		/* GANԂŁAAEtB[hԂȂ΁A~XłB */
		if((game.area_stat == AREA_STAT_MISS) &&
		   !game.side[0].active &&
		   !game.side[1].active) {
			goto L_MISS;
		}

		/* wi`܂B */
		bg_disp();

		/* GA`܂B */
		area_disp();

		/* A`܂B */
		awa_disp();

		/* tB[h`܂B */
		field_disp(0);
		field_disp(1);

		/* `܂B */
		taco_disp();

		/* XRA`܂B */
		score_disp(0);

		/* GO\B */
		if(go_disp) {
			x = (DISP_X - (4 * 2 + 2)) / 2;
			y = (DISP_Y - (6     + 2)) / 2;
			render_string_framed(&render, x, y, "GO", 0x82, 0x330);
			go_disp--;
		}

		/* xAbvB */
		for(;;) {
			if(game.erase_cnt < levelup_cnt) {
				break;
			}
			game.erase_cnt -= levelup_cnt;
			game.level++;
			levelup_cnt = LEVELUP_CNT;
		}
	}

L_MISS:
	/* Q[I[o[os܂B */
	game_miss();

	/* nCXRAXVB */
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	game_ready
 ****************************************************************************/

void
game_ready()
{
	int x;
	int y;
	//
	int title_y = 0;

	/* JnOԂɂ܂B */
	game.taco_stat = TACO_STAT_READY;
	game.taco_cnt = DISP_Y;

	for(;;) {
		game.taco_cnt -= 2;
		if(game.taco_cnt <= 0) {
			game.taco_cnt = 0;
			break;
		}
		schedule();

		/* ͍̏s܂B */

		/* tB[h͍̏s܂B */

		/* wi`܂B */
		bg_disp();

		/* GA`܂B */
		area_disp();

		/* tB[h`܂B */
		field_disp(0);
		field_disp(1);

		/* `܂B */
		taco_disp();

		/* ^Cgޏꂵ܂B */
		x = 0;
		y = --title_y;
		sprite_draw(0, y, SPR_TITLE, 0);

		/* XRA`܂B */
		score_disp(0);

		/* READY\B */
		if(game.taco_cnt <= SEC(1.5) * 2) {
			x = (DISP_X - (4 * 5 + 2)) / 2;
			y = (DISP_Y - (6     + 2)) / 2;
			render_string_framed(&render, x, y, "READY", 0x82, 0x331);
		}
	}

	/* ʏԂɂ܂B */
	game.taco_stat = 0;
}

/****************************************************************************
 *	game_miss
 ****************************************************************************/

void
game_miss()
{
	static const char miss_shift[] = { 3,6,4,2, 0,3,1,0, 0,0,0,0 };
	//
	int i;
	int n;
	int x;
	int y;

	/* ~XԂɂ܂B */
	game.taco_stat = TACO_STAT_MISS;
	game.taco_cnt = 0;

	/* ʂU܂B */
	for(i = 0; i < ARRAY_SIZE(miss_shift); i++) {
		schedule();

		/* Ȁs܂B */
		awa_action();

		/* ͍̏s܂B */

		/* tB[h͍̏s܂B */

		/* wi`܂B */
		bg_disp();

		/* GA`܂B */
		area_disp();

		/* A`܂B */
		awa_disp();

		/* tB[h`܂B */
		field_disp(0);
		field_disp(1);

		/* `܂B */
		taco_disp();

		/* ʂU܂B */
		n = miss_shift[i];
		memmove(&vbuff[0], &vbuff[DISP_X * n], DISP_X * (DISP_Y - n));

		/* XRA`܂B */
		score_disp(0);
	}

	/* X~͂ătF[hAEg܂B */
	for(i = 0; i < SEC(10); i++) {
		schedule();

		/* X~𐶐܂B */
		ink_gen();

		/* X~̏s܂B */
		ink_action();

		/* Ȁs܂B */
		awa_action();

		/* ͍̏s܂B */

		/* tB[h͍̏s܂B */

		/* wi`܂B */
		bg_disp();

		/* GA`܂B */
		area_disp();

		/* A`܂B */
		awa_disp();

		/* tB[h`܂B */
		field_disp(0);
		field_disp(1);

		/* `܂B */
		taco_disp();

		/* X~`܂B */
		ink_disp();

		/* tF[hAEg܂B */
		n = (i - SEC(1.5/**/)) / SEC(0.2/**/);
		if(n <= 0) {
			/** no job **/
		} else if(n <= 3) {
			brightness(0, 0, DISP_X - 1, DISP_Y - 1, n);
		} else {
			surface_clear(&surface, 3);
			x = (DISP_X - (4 * 9 + 2)) / 2;
			y = (DISP_Y - (6     + 2)) / 2;
			render_string_framed(&render, x, y, "GAME OVER", 0x82, 0x203);
			if(i > SEC(3)) {
				if(joy & (TRG_A | TRG_B)) {
					break;
				}
			}
		}

		/* XRA`܂B */
		score_disp(0);
	}
}

/****************************************************************************
 *	get_blank_cols
 ****************************************************************************/

/* tB[hNU̐擪񂩂AA𐔂܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		񐔁B(0`FIELD_COLS)
 */
int
get_blank_cols(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;
	int col;
	int row;
	int dir;
	int cnt;

	/* EtB[hȂ΍EցAtB[hȂΉE獶֑܂B */
	if(i_side) {
		col = 0;		/* Jn */
		dir = 1;		/*  */
	} else {
		col = FIELD_COLS - 1;	/* Jn */
		dir = -1;		/*  */
	}

	/* tB[h𐅕ɑ... */
	for(cnt = 0; cnt < FIELD_COLS; cnt++, col += dir) {

		/* ݂̗𐂒ɑ... */
		for(row = FIELD_ROWS - 1; row >= 0; row--) {
			cell = &side->field[row][col];

			/* Ȃ΁AO܂ł̗񐔂Ԃ܂B */
			if(cell->color) {
				return cnt;
			}
		}
	}

	return cnt;
}

/****************************************************************************
 *	get_field_pos
 ****************************************************************************/

/* tB[hNU̐擪́AZ`挴_XW擾܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		Z`挴_XWB
 * [note]
 *	* ߂ĺAgZ`挴_XWhł邱ƂɒӂĂB
 *	- tB[h̏ꍇAłȂE[́A[sNZXWƂȂ܂B
 *	                                        E[sNZł͂܂!!
 *	- EtB[h̏ꍇAłȂ[́A[sNZXWƂȂ܂B
 */
int
get_field_pos(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int col;

	/* tB[hNU̐擪񂩂AA𐔂܂B */
	col = get_blank_cols(i_side);

	/* tB[hNU̐擪߂܂B */
	if(i_side) { /* EtB[h */
		/** no job **/
	} else {     /* tB[h */
		col = (FIELD_COLS - 1) - col;
	}

	/* tB[hNU̐擪́AZ`挴_XW߂܂B */
	return FIELD_X + CELL_W * col + fist(side->ofs);
}

/****************************************************************************
 *	get_area_stat
 ****************************************************************************/

int
get_area_stat()
{
	int diff;
	int stat;

	/* EtB[h̊ԊuɂāAGAԂI܂B */
	diff = game.side[1].pos - game.side[0].pos;
	if(diff < MISS_W) {
		stat = AREA_STAT_MISS;	/* ~X */
	} else if(diff < WARN_W) {
		stat = AREA_STAT_WARN;	/* x */
	} else if(diff < SPDUP_W) {
		stat = 0;		/* ʏ */
	} else {
		stat = AREA_STAT_SPDUP;	/* NU */
	}

	return stat;
}

/****************************************************************************
 *	erase_mark
 ****************************************************************************/

/* w肳ꂽFƓŁAʏԂ̃Z̗אڂ}[NAאڐ𐔂܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 *	col		B
 *	row		sB
 *	color		FB
 * [out]
 *	߂l		אڐB
 * [note]
 *	* erase_mark()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
erase_mark_sub(int i_side, int col, int row, int color)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;

	/* ʊOȂ΁AA܂B */
	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return 0;
	}

	/* ɈvȂ΁AA܂B */
	cell = &side->field[row][col];
	if((cell->color != color) ||	/* FႤor */
	   cell->stat ||		/* ʏԂłȂ */
	   cell->mark) {		/* Ƀ}[Nς */
		return 0;
	}

	/* }[N܂B */
	cell->mark = 1;

	/* ㉺EɍċA܂B */
	return 1/*̕𐔂*/
	     + erase_mark_sub(i_side, col - 1, row, color)
	     + erase_mark_sub(i_side, col + 1, row, color)
	     + erase_mark_sub(i_side, col, row - 1, color)
	     + erase_mark_sub(i_side, col, row + 1, color);
}

/* N_̃Z̐FƓŁAʏԂ̃Z̗אڂ}[NAאڐ𐔂܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 *	col		B
 *	row		sB
 * [out]
 *	߂l		אڐB
 */
int
erase_mark(int i_side, int col, int row)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;

	/* ʊOȂ΁AA܂B */
	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return 0;
	}

	/* N_ɃZ΁AA܂B */
	cell = &side->field[row][col];
	if(!cell->color) {
		return 0;
	}

	/* N_̃Z̐FƓŁAʏԂ̃Z̗אڂ}[NAאڐ𐔂܂B */
	return erase_mark_sub(i_side, col, row, cell->color);
}

/****************************************************************************
 *	erase_init
 ****************************************************************************/

/* }[NĂZ̗אڂ}[NAw肪L΁AŊJn܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 *	col		B
 *	row		sB
 *	init		0 = ŊJnȂ, 1 = ŊJn
 */
void
erase_init(int i_side, int col, int row, int init)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;

	/* ʊOȂ΁AA܂B */
	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return;
	}

	/* ɈvȂ΁AA܂B */
	cell = &side->field[row][col];
	if(!cell->mark) {	/* }[NĂȂorɉς */
		return;
	}

	/* }[N܂B */
	cell->mark = 0;

	/* w肪L΁AŊJn܂B */
	if(init) {
		cell->stat = CELL_STAT_ERASE;
		cell->cnt = 0;
	}

	/* ㉺EɍċA܂B */
	erase_init(i_side, col - 1, row, init);
	erase_init(i_side, col + 1, row, init);
	erase_init(i_side, col, row - 1, init);
	erase_init(i_side, col, row + 1, init);
}

/****************************************************************************
 *	field_gen
 ****************************************************************************/

/* tB[hNU̖[ɁAVZ𐶐܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 *	height		Z̍B
 * [note]
 *	* VZ̐ɂāAɏłȂ悤Asd˂܂B
 *	  AsEɒBꍇ́Aw肳ꂽŁA𒆒f܂B
 *	  ̏ꍇɂA{֐́AʏǂɏԂ܂B
 */
void
field_gen(int i_side, int height)
{
	SIDE* side = &game.side[i_side];
	//
	int retry = 100; /*  */
	//
	CELL* cell;
	int col;
	int row;
	int h;
	int n;
	int c0;
	int c1;

	/* EtB[h */
	if(i_side) {
		/* tB[hŜAЂƂɂ炵܂B */
		memmove(&side->field[0][0], &side->field[0][1],
			sizeof(CELL) * (FIELD_COLS * FIELD_ROWS - 1));

		/* ́AE[łB */
		col = FIELD_COLS - 1;

	/* tB[h */
	} else {
		/* tB[hŜAЂƂEɂ炵܂B */
		memmove(&side->field[0][1], &side->field[0][0],
			sizeof(CELL) * (FIELD_COLS * FIELD_ROWS - 1));

		/* ́A[łB */
		col = 0;
	}

	/* ܂ANA܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		cell = &side->field[row][col];
		memset(cell, 0, sizeof(CELL));
	}

	/* w肳ꂽ܂ŁAZ𐶐܂B */
	h = 0;
	for(;;) {
		row = (FIELD_ROWS - 1) - h;
		cell = &side->field[row][col];

		/* Ƃ4F̏ꍇÂꂩ̏ԂŐ݂܂B
		 *	{1,2,3,4}
		 *	{2,3,4,1}
		 *	{3,4,1,2}
		 *	{4,1,2,3}
		 */
		c0 = RND16_RANGE(game.seed, 0, COLORS);
		for(c1 = 0; c1 < COLORS; c1++) {
			cell->color = 1 + (c0 + c1) % COLORS;

			/* łȂ΁A̐F̗p܂B */
			n = erase_mark(i_side, col, row);
			    erase_init(i_side, col, row, 0);
			if(n < 3) {
				break;
			}
		}

		/* ̗płFL... */
		if(c1 < COLORS) {

			/* w肳ꂽɒBĂȂ΁A̍sցB */
			if(h < height - 1) {
				h++;

			/* w肳ꂽɒBĂA܂B */
			} else {
				break;
			}

		/* ̗płF... */
		} else {

			/* ̍sɐZALZ܂B */
			cell->color = 0;

			/* gCEɒBĂȂ... */
			if(--retry) {

				/* ŉsłȂ΁A̍s蒼܂B */
				if(h > 0) {
					h--;

				/* ŉsŎs邱Ƃ́AL蓾Ȃ͂łB */
				} else {
					DIE(); /* L蓾Ȃ */
				}

			/* gCEɒBAŝ܂܁A܂B */
			} else {
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/* s[X`܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [note]
 *	* fieid_disp()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
field_disp_piece(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;
	int col;
	int row;
	int x;
	int y;
	int sprno;
	int ptn;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			x = FIELD_X + CELL_W * col + fist(side->ofs);
			y = FIELD_Y + CELL_H * row;
			sprno = pat_pce[cell->color - 1];

			switch(cell->stat) {
			case CELL_STAT_FALL:
				y -= cell->cnt;
				break;

			case CELL_STAT_ERASE:
				ptn = cell->cnt / (ERASE_TIME / (4/*p^[*/ + 1/*\()*/));
				if(ptn < 4) {
					sprno += ptn;
				} else {
					sprno = -1;
				}
				break;
			}

			if(sprno >= 0) {
				sprite_draw(x, y, sprno, DRW_NOMAL);
			}
		}
	}
}

/* GtFNg`܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [note]
 *	* fieid_disp()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
field_disp_effect(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	CELL* cell;
	int col;
	int row;
	int x;
	int y;
	int sprno;
	int rot;
	int mag;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			x = FIELD_X + CELL_W * col + fist(side->ofs);
			y = FIELD_Y + CELL_H * row;
			sprno = -1;

			switch(cell->stat) {
			case CELL_STAT_ERASE:
				if(cell->cnt < ERASE_TIME) {
					/* rot = (int)(sin( * cnt / ERASE_TIME) * 13 + 0.5) */
					rot = fist(fadd(fimul(fsin(fidiv(fimul(PI, cell->cnt), ERASE_TIME)), 13/*TCY=0`13*/), fld(0.5)));
					mag = 32/*]16p^[~2*/ * cell->cnt / ERASE_TIME % 16/*]16p^[*/;
					sprno = SPR_EFF00 + rot * 16 + mag;
				}
				break;
			}

			if(sprno >= 0) {
				sprite_draw(x, y, sprno, DRW_NOMAL);
			}
		}
	}
}

/* tB[h`܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 */
void
field_disp(int i_side)
{
	/* s[X`܂B */
	field_disp_piece(i_side);

	/* GtFNg`܂B */
	field_disp_effect(i_side);
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

/* ̃ŹAp܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		pZ΁A0ȊO̒lԂ܂B
 *			Ȃ΁A0Ԃ܂B
 * [note]
 *	* field_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
field_action_fall_advance(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int active = 0;
	//
	CELL* cell;
	int col;
	int row;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			switch(cell->stat) {
			case CELL_STAT_FALL:
				cell->cnt -= FALL_SPD;
				if(cell->cnt <= 0) {
					if((row < FIELD_ROWS - 1) && !(cell + FIELD_COLS)->color) {
						cell->cnt += CELL_H;
						memcpy(cell + FIELD_COLS, cell, sizeof(CELL));
						memset(cell, 0, sizeof(CELL));
					} else {
						cell->stat = 0;
					}
				}
				active = 1;
				break;
			}
		}
	}

	return active;
}

/* VJn܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		JnZ΁A0ȊO̒lԂ܂B
 *			Ȃ΁A0Ԃ܂B
 * [note]
 *	* field_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
field_action_fall_start(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int active = 0;
	//
	CELL* cell;
	int col;
	int row;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			switch(cell->stat) {
			case 0:
				if((row < FIELD_ROWS - 1) && !(cell + FIELD_COLS)->color) {
					cell->stat = CELL_STAT_FALL;
					cell->cnt = CELL_H - FALL_SPD;
					memcpy(cell + FIELD_COLS, cell, sizeof(CELL));
					memset(cell, 0, sizeof(CELL));
					active = 1;
				}
				break;
			}
		}
	}

	return active;
}

/* Œ̃ŹAłp܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		łpZ΁A0ȊO̒lԂ܂B
 *			Ȃ΁A0Ԃ܂B
 * [note]
 *	* field_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
field_action_erase_advance(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int active = 0;
	//
	CELL* cell;
	int col;
	int row;
	int i;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			switch(cell->stat) {
			case CELL_STAT_ERASE:
				cell->cnt++;
				if(cell->cnt == ERASE_TIME / 4) {
					for(i = 0; i < 4/**/; i++) {
						awa_gen(i_side, col, row);
					}
				}
				if(cell->cnt >= ERASE_TIME) {
					memset(cell, 0, sizeof(CELL));
				}
				active = 1;
				break;
			}
		}
	}

	return active;
}

/* VłJn܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		łJnZ΁A0ȊO̒lԂ܂B
 *			Ȃ΁A0Ԃ܂B
 * [note]
 *	* field_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
field_action_erase_start(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int active = 0;
	//
	CELL* cell;
	int col;
	int row;
	int n;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &side->field[row][col];
			if(!cell->color) {
				continue;
			}

			switch(cell->stat) {
			case 0:
				n = erase_mark(i_side, col, row);
				if(n >= 3) {
					erase_init(i_side, col, row, 1);
					/*{{XRAZ*/
					game.score += (n * 10) * (game.chain + 1);
					/*}}XRAZ*/
					active = 1;
				} else {
					erase_init(i_side, col, row, 0);
				}
				break;
			}
		}
	}

	return active;
}

/* w肳ꂽNUOɂAւ炵܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 *	col		B
 * [note]
 *	* EtB[h̏ꍇANU [0][FIELD_COLS-1] łB
 *	  ]āA{֐̓́Â悤ɂȂ܂B
 *		[col-1]̓eA[col  ]ֈړB
 *		[col-2]̓eA[col-1]ֈړB
 *				E
 *				E
 *				E
 *		[0]̓eA[1]ֈړB
 *		[0]̓eAB
 *	* tB[h̏ꍇANU [0][FIELD_COLS-1] łB
 *	  ]āA{֐̓́Â悤ɂȂ܂B
 *		[col+1]̓eA[col  ]ֈړB
 *		[col+2]̓eA[col+1]ֈړB
 *				E
 *				E
 *				E
 *		[FIELD_COLS-1]̓eA[FIELD_COLS-2]ֈړB
 *		[FIELD_COLS-1]̓eAB
 *	* field_action_shift()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
field_action_shift_sub(int i_side, int col)
{
	SIDE* side = &game.side[i_side];
	//
	int row;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {

		/* EtB[h */
		if(i_side) {
			memmove(&side->field[row][1],
				&side->field[row][0], 
				sizeof(CELL) * col);
			memset(&side->field[row][0], 0, sizeof(CELL));

		/* tB[h */
		} else {
			memmove(&side->field[row][col    ],
				&side->field[row][col + 1],
				sizeof(CELL) * ((FIELD_COLS - 1) - col));
			memset(&side->field[row][FIELD_COLS - 1], 0, sizeof(CELL));
		}
	}
}

/* l߂܂B
 * [in]
 *	i_side		0 = tB[h, 1 = EtB[hB
 * [out]
 *	߂l		ۂɋl߂A0ȊO̒lԂ܂B
 *			Ȃ΁A0Ԃ܂B
 * [note]
 *	* field_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static int
field_action_shift(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	int active = 0;
	//
	CELL* cell;
	int col;
	int row;
	int dir;
	int cnt;

	/* EtB[hȂ΍EցAtB[hȂΉE獶֑܂B */
	if(i_side) {
		col = 0;		/* Jn */
		dir = 1;		/*  */
	} else {
		col = FIELD_COLS - 1;	/* Jn */
		dir = -1;		/*  */
	}

	/* tB[hNU̐擪񂩂AAXLbv܂B */
	cnt = get_blank_cols(i_side);	/* JE^ */
	col += cnt * dir;		/* ŏ̔ */

	/* ȍ~ɋ𔭌Al߂܂B */
	while(cnt < FIELD_COLS) {
		for(row = FIELD_ROWS - 1; row >= 0; row--) {
			cell = &side->field[row][col];
			if(cell->color) {
				break;
			}
		}
		if(row < 0) {
			field_action_shift_sub(i_side, col);
			active = 1;
		}
		col += dir;	/* ̗ */
		cnt++;		/* JE^i߂ */
	}

	return active;
}

static void
field_action_invasion(int i_side)
{
	SIDE* side = &game.side[i_side];
	//
	fixed spd;

	/* GAԂɂāAtB[h̐NUx肵܂B */
	switch(game.area_stat) {
	case 0:
		spd = FIELD_SPD;
		if(joy & PAD_SELECT) {
			spd = fild(FIELD_SPD_MAX);
			game.score++;
		}
		break;
	case AREA_STAT_SPDUP:
		spd = fild(FIELD_SPD_MAX);
		break;
	case AREA_STAT_WARN:
		spd = fidiv(FIELD_SPD, 2);
		if(joy & PAD_SELECT) {
			spd = fild(FIELD_SPD_MAX);
			game.score++;
		}
		break;
	case AREA_STAT_MISS:
		spd = fild(0);
		break;
	default:
		DIE();
	}

	/* EtB[h */
	if(i_side) {

		/* ItZbg֐i߂܂B */
		side->ofs = fsub(side->ofs, spd);

		/* ItZbgZE𒴂... */
		while(ficom(side->ofs, <=, 0)) {

			/* ItZbgE1ZA߂܂B */
			side->ofs = fiadd(side->ofs, CELL_W);

			/* VZ𐶐܂B */
			field_gen(i_side, HEIGHT);
		}

	/* tB[h */
	} else {

		/* ItZbgE֐i߂܂B */
		side->ofs = fadd(side->ofs, spd);

		/* ItZbgZE𒴂... */
		while(ficom(side->ofs, >=, 0)) {

			/* ItZbg1ZA߂܂B */
			side->ofs = fisub(side->ofs, CELL_W);

			/* VZ𐶐܂B */
			field_gen(i_side, HEIGHT);
		}
	}
}

void
field_action(int i_side)
{
	SIDE* side = &game.side[i_side];

	/* ܂AԂƂĂ܂B */
	side->active = 0;

	/* l߂܂B */
	side->active |= field_action_shift(i_side);

	/* ̃ŹAp܂B */
	side->active |= field_action_fall_advance(i_side);

	/* VJn܂B */
	side->active |= field_action_fall_start(i_side);

	/* Œ̃ŹAłp܂B */
	side->active |= field_action_erase_advance(i_side);

	/* VłJn܂B
	 * - ĂяoŎQƂ邽߂ɁAŊJn̗LL^Ă܂B
	 */
	side->erase = field_action_erase_start(i_side);
	side->active |= side->erase;

	/* ԂȂ΁ANU܂B */
	if(!side->active) {
		field_action_invasion(i_side);
	}

	/* tB[h[̃Z_WXV܂B */
	side->pos = get_field_pos(i_side);
}

/****************************************************************************
 *	bg_disp
 ****************************************************************************/

void
bg_disp()
{
	int i;
	int x;

	i = now % 2;
	x = now / SEC(0.25/**/) % DISP_X;

	/* C */
	sprite_draw(x         , 0, SPR_SEA0 + i, DRW_NOMAL);
	sprite_draw(x - DISP_X, 0, SPR_SEA0 + i, DRW_NOMAL);

	/* C */
	sprite_draw(0, 0, SPR_GND0 + i, DRW_NOMAL);
}

/****************************************************************************
 *	area_disp
 ****************************************************************************/

static const char area_color [] = { 3,3,3, 2, 1, 2 };
static const char area_adjust[] = { 0,0,0,-1,-2,-1 };

void
area_disp()
{
	int x;
	int y;
	int x1;
	int y1;
	int x2;
	int y2;
	int color;
	int adjust;

	/* ̍W擾܂B */
	x = game.taco_pos;
	y = FIELD_Y + CELL_H * game.taco_row + game.taco_ofs;

	/* GAW߂܂B */
	x1 = x - AREA_LF;
	x2 = x + AREA_RI;
	y1 = 0;
	y2 = FIELD_Y + CELL_H * FIELD_ROWS;
	if(game.taco_stat == TACO_STAT_READY) {
		x1 += game.taco_cnt / 2;
		x2 -= game.taco_cnt / 2;
		if(x1 > x2) {
			return;
		}
	}

	/* GAԂɂāAF肵܂B */
	switch(game.area_stat) {
	case 0:
	case AREA_STAT_SPDUP:
		color  = 3;
		adjust = 0;
		break;
	case AREA_STAT_WARN:
	case AREA_STAT_MISS:
		if(game.taco_stat == TACO_STAT_MISS) { /* Q[I[o[o͓_Ŗ */
			color  = 3;
			adjust = 0;
		} else {
			color  = area_color [now / 4 % ARRAY_SIZE(area_color )];
			adjust = area_adjust[now / 4 % ARRAY_SIZE(area_adjust)];
		}
		break;
	default:
		DIE();
	}

	/* GAẼfbhC`܂B */
	render_line(&render, x1, y1, x1, y2, color);
	render_line(&render, x2, y1, x2, y2, color);

	/* fbhC̓̋Px𒲐܂B */
	brightness(x1 + 1, y1/*+1sv*/, x2 - 1, y2 - 1, adjust);
}

void
score_disp(int demo)
{
	static const short chain_shift[] = { 40,32,24,16,8,0,-8,0,-4,0,-2, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 8,16,24,32,40 };
	//
	int x;
	int y;

	/* nCXRAA܂́Ax */
	x = LEVEL_X;
	y = LEVEL_Y;
	if(demo) {
		render_string(&render, x, y, "HI", 0x82, 1);
		x += 4 * 2 + 2;
		render_printf(&render, x, y, 0x82, 2, "%08d", hiscore < 99999999 ? hiscore : 99999999);
		render_printf(&render, x, y, 0x82, 0, "%8d" , hiscore < 99999999 ? hiscore : 99999999);
	} else {
		render_string(&render, x, y, "LEVEL", 0x82, 1);
		x += 4 * 5 + 2;
		render_printf(&render, x, y, 0x82, 2, "%02d", game.level < 99 ? game.level : 99);
		render_printf(&render, x, y, 0x82, 0, "%2d" , game.level < 99 ? game.level : 99);

		/* A */
		if(game.chain_val >= 2) {
			if(game.chain_cnt < ARRAY_SIZE(chain_shift)) {
				x = CHAIN_X + chain_shift[game.chain_cnt];
				y = CHAIN_Y;
				render_printf_framed(&render, x, y, 0x81, 0x331, "%2d", game.chain_val <= 99 ? game.chain_val : 99);
				x += 17;
				y += 10;
				render_string_framed(&render, x, y, "CHAIN", 0x82, 0x330);
				game.chain_cnt++;
			} else {
				game.chain_val = 0;
			}
		}
	}

	/* XRA */
	x = SCORE_X;
	y = SCORE_Y;
	render_string(&render, x, y, "SCORE", 0x82, 1);
	x += 4 * 5 + 2;
	render_printf(&render, x, y, 0x82, 2, "%08d", game.score < 99999999 ? game.score : 99999999);
	render_printf(&render, x, y, 0x82, 0, "%8d" , game.score < 99999999 ? game.score : 99999999);
}

/****************************************************************************
 *	taco_disp
 ****************************************************************************/

/* z݁AԂ̏ꍇ́AKChj`܂B
 * [note]
 *	* taco_disp()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
taco_disp_guide()
{
	static const unsigned char dash[] = { 0,4,4,4,4,4 };
	//
	SIDE* side;
	CELL* cell;
	int col;
	int row;
	int i;
	int x;
	int y;
	int pos;

	/* jp^[肵܂B */
	i = (now / 2) % ARRAY_SIZE(dash);
	switch(game.taco_stat) {
	case 0:
		/** no job **/
		break;
	case TACO_STAT_KEEP:
		i = (ARRAY_SIZE(dash) - 1) - i;
		break;
	default:
		DIE();
	}

	/* ̒SW擾܂B */
	x = game.taco_pos + 2;
	y = FIELD_Y + CELL_H * game.taco_row + game.taco_ofs + 4;

	/* tB[h */
	side = &game.side[0];
	row = game.taco_row;
	for(col = FIELD_COLS - 1; col > 0; col--) {
		cell = &side->field[row][col - 1];
		if(cell->color) {
			break;
		}
	}
	pos = FIELD_X + CELL_W * col + fist(side->ofs) - 1;
	if(pos < x) {
		render_dashes(&render, x, y, pos, y, i, dash, ARRAY_SIZE(dash));
	}

	/* EtB[h */
	side = &game.side[1];
	row = game.taco_row;
	for(col = 0; col < FIELD_COLS - 1; col++) {
		cell = &side->field[row][col + 1];
		if(cell->color) {
			break;
		}
	}
	pos = FIELD_X + CELL_W * col + fist(side->ofs) + CELL_W;
	if(pos > x) {
		render_dashes(&render, x, y, pos, y, i, dash, ARRAY_SIZE(dash));
	}
}

void
taco_disp()
{
	int x;
	int y;
	int sprno;

	/* ̍W擾܂B */
	x = game.taco_pos;
	y = FIELD_Y + CELL_H * game.taco_row + game.taco_ofs;
	if(game.taco_stat == TACO_STAT_READY) {
		y -= game.taco_cnt;
	}

	/*  */
	if(game.taco_stat == TACO_STAT_READY) {
		sprite_draw(x, -game.taco_cnt, SPR_BAR, DRW_NOMAL);
	} else {
		sprite_draw(x,               0, SPR_BAR, DRW_NOMAL);
	}

	/* KCh */
	switch(game.taco_stat) {
	case 0:
	case TACO_STAT_KEEP:
		taco_disp_guide();
		break;
	case TACO_STAT_VACUUM_LF:
	case TACO_STAT_VACUUM_RI:
	case TACO_STAT_THROW_LF:
	case TACO_STAT_THROW_RI:
	case TACO_STAT_READY:
	case TACO_STAT_MISS:
		/** no job **/
		break;
	default:
		DIE();
	}

	/*  () */
	switch(game.taco_stat) {
	case 0:
	case TACO_STAT_KEEP:
	case TACO_STAT_VACUUM_LF:
	case TACO_STAT_VACUUM_RI:
	case TACO_STAT_THROW_LF:
	case TACO_STAT_THROW_RI:
	case TACO_STAT_READY:
		sprno = SPR_LEG0 + (now / 4) % 8;
		break;
	case TACO_STAT_MISS:
		sprno = SPR_LEG0;
		break;
	default:
		DIE();
	}
	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}

	/*  */
	switch(game.taco_stat) {
	case 0:
	case TACO_STAT_KEEP:
	case TACO_STAT_READY:
	case TACO_STAT_MISS:
		sprno = SPR_HEDc;
		break;
	case TACO_STAT_VACUUM_LF:
	case TACO_STAT_THROW_LF:
		sprno = SPR_HEDl;
		break;
	case TACO_STAT_VACUUM_RI:
	case TACO_STAT_THROW_RI:
		sprno = SPR_HEDr;
		break;
	default:
		DIE();
	}
	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}

	/* s[X */
	switch(game.taco_stat) {
	case TACO_STAT_THROW_LF:
	case TACO_STAT_THROW_RI:
		y = FIELD_Y + CELL_H * game.cell_row;
		/* FALLTHRU */
	case TACO_STAT_VACUUM_LF:
	case TACO_STAT_VACUUM_RI:
		x = game.cell_pos;
		/* FALLTHRU */
	case TACO_STAT_KEEP:
		sprno = pat_pce[game.cell_color - 1];
		break;
	case 0:
	case TACO_STAT_READY:
	case TACO_STAT_MISS:
		sprno = -1;
		break;
	default:
		DIE();
	}
	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}

	/* ̍WĎ擾܂B(s[X̍Wɂj󂳂Ă邽) */
	x = game.taco_pos;
	y = FIELD_Y + CELL_H * game.taco_row + game.taco_ofs;
	if(game.taco_stat == TACO_STAT_READY) {
		y -= game.taco_cnt;
	}

	/*  (ʏAz)A܂́Ar (A) */
	switch(game.taco_stat) {
	case 0:
	case TACO_STAT_VACUUM_LF:
	case TACO_STAT_VACUUM_RI:
	case TACO_STAT_READY:
		sprno = SPR_LEG0 + (now / 4 + 4) % 8;
		break;
	case TACO_STAT_MISS:
		sprno = SPR_LEG0 + 4;
		break;
	case TACO_STAT_KEEP:
		sprno = SPR_ARMc;
		break;
	case TACO_STAT_THROW_LF:
	case TACO_STAT_THROW_RI:
		if(game.taco_cnt <= SEC(0.5/**/)) {
			if(game.taco_stat == TACO_STAT_THROW_LF) {
				sprno = SPR_ARMl;
			} else {
				sprno = SPR_ARMr;
			}
		} else {
			sprno = -1;
		}
		break;
	default:
		DIE();
	}
	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}

	/* z݃GtFNg */
	switch(game.taco_stat) {
	case TACO_STAT_VACUUM_LF:
		sprno = SPR_VCMl0 + now % 6;
		break;
	case TACO_STAT_VACUUM_RI:
		sprno = SPR_VCMr0 + now % 6;
		break;
	case 0:
	case TACO_STAT_KEEP:
	case TACO_STAT_THROW_LF:
	case TACO_STAT_THROW_RI:
	case TACO_STAT_READY:
	case TACO_STAT_MISS:
		sprno = -1;
		break;
	default:
		DIE();
	}
	if(sprno >= 0) {
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}
}

/****************************************************************************
 *	taco_action
 ****************************************************************************/

/* 𐅕ړ܂B
 * [note]
 *	* taco_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
taco_action_move_x()
{
	int pos;

	/* EtB[h̒W߂܂B */
	pos = (game.side[0].pos + game.side[1].pos + 1) / 2;

	/* 𐅕ړ܂B(ړx = tB[hNUő呬x) */
	if(game.taco_pos < pos) {
		game.taco_pos += FIELD_SPD_MAX;
		if(game.taco_pos > pos) {
			game.taco_pos = pos;
		}
	} else {
		game.taco_pos -= FIELD_SPD_MAX;
		if(game.taco_pos < pos) {
			game.taco_pos = pos;
		}
	}
}

/* 𐂒ړ܂B
 * [note]
 *	* taco_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
taco_action_move_y()
{
	/* ړJnA܂́Aړړւ̔]B */
	if((joy & PAD_UP) && (game.taco_row > 0)) {
		if(game.taco_ofs <= 0) { /* ~A܂́Aړ */
			game.taco_row--;
			game.taco_ofs += CELL_H;
		}

	/* ړJnA܂́Aړ牺ړւ̔]B */
	} else if((joy & PAD_DN) && (game.taco_row < FIELD_ROWS - 1)) {
		if(game.taco_ofs >= 0) { /* ~A܂́Aړ */
			game.taco_row++;
			game.taco_ofs -= CELL_H;
		}
	}

	/* ړpB(ړJnA܂́Aړړւ̔]܂) */
	if(game.taco_ofs > 0) {
		game.taco_ofs -= TACO_SPD;
		if(game.taco_ofs <= 0) { /* p */
			if((joy & PAD_UP) && (game.taco_row > 0)) {
				game.taco_row--;
				game.taco_ofs += CELL_H;
			} else { /*  */
				game.taco_ofs = 0;
			}
		}

	/* ړpB(ړJnA܂́Aړ牺ړւ̔]܂) */
	} else if(game.taco_ofs < 0) {
		game.taco_ofs += TACO_SPD;
		if(game.taco_ofs >= 0) { /* p */
			if((joy & PAD_DN) && (game.taco_row < FIELD_ROWS - 1)) {
				game.taco_row++;
				game.taco_ofs -= CELL_H;
			} else { /*  */
				game.taco_ofs = 0;
			}
		}
	}
}

/* z݁AȀs܂B
 * [note]
 *	* taco_action()痘p܂B
 *	  ځAĂяoȂłB
 */
static void
taco_action_cell()
{
	SIDE* side;
	CELL* cell;
	int i_side;
	int col;
	int row;
	int dir;
	int cnt;
	int pos;

	/* ʏ큨z݁Ȁs܂B */
	switch(game.taco_stat) {
	case 0:
		/* A(RI)A܂́AB(LF){^ꂽ... */
		if(joy & (TRG_A | TRG_B | TRG_LF | TRG_RI)) {

			/* zݕI܂B */
			if(joy & (TRG_A | TRG_RI)) {
				i_side = 1; /* EtB[h */
				col = 0;
				dir = 1;
			} else {
				i_side = 0; /* tB[h */
				col = FIELD_COLS - 1;
				dir = -1;
			}

			/* ̌ݍsAtB[h擪疖[֑... */
			side = &game.side[i_side];
			row = game.taco_row;
			for(cnt = 0; cnt < FIELD_COLS; cnt++, col += dir) {
				cell = &side->field[row][col];

				/* Z𔭌... */
				if(cell->color) {
					switch(cell->stat) {
					case 0:
					case CELL_STAT_FALL:
						/* ʏA܂́ÃZȂ΁Az݂܂B */
						game.cell_color = cell->color;
						game.cell_row = row;
						game.cell_pos = FIELD_X + CELL_W * col + fist(side->ofs);
						if(i_side) {
							game.taco_stat = TACO_STAT_VACUUM_RI;
						} else {
							game.taco_stat = TACO_STAT_VACUUM_LF;
						}
						memset(cell, 0, sizeof(CELL));
						break;
					default:
						/* ȊȌԂ̃ZȂ΁A܂B */
						break;
					}

					/* z݂̉ۂɂ炸AI܂B
					 * z߂ȂZ΂āǍɂZzނƂ͂܂B
					 */
					break;
				}
			}
		}
		break;

	case TACO_STAT_KEEP:
		/* A(RI)A܂́AB(LF){^ꂽ... */
		if(joy & (TRG_A | TRG_B | TRG_LF | TRG_RI)) {

			/* I܂B */
			if(joy & (TRG_A | TRG_RI)) {
				game.taco_stat = TACO_STAT_THROW_RI;
			} else {
				game.taco_stat = TACO_STAT_THROW_LF;
			}
			game.cell_row = game.taco_row;
			game.cell_pos = game.taco_pos;
			game.taco_cnt = 0; /* p^[\Ԃ̃JE^ */
		}
		break;
	}

	/* z݁Ȁs܂B
	 * ŁAz݁AJnꍇ́A̓܂݂܂B
	 */
	switch(game.taco_stat) {
	case TACO_STAT_VACUUM_LF:
		game.cell_pos += CELL_SPD;
		if(game.cell_pos >= game.taco_pos) {
			game.taco_stat = TACO_STAT_KEEP;
		}
		break;

	case TACO_STAT_VACUUM_RI:
		game.cell_pos -= CELL_SPD;
		if(game.cell_pos <= game.taco_pos) {
			game.taco_stat = TACO_STAT_KEEP;
		}
		break;

	case TACO_STAT_THROW_LF:
		game.taco_cnt++; /* p^[\Ԃ̃JE^ */
		game.cell_pos -= CELL_SPD;
		side = &game.side[0];
		row = game.cell_row;
		for(col = FIELD_COLS - 1; col > 0; col--) {
			cell = &side->field[row][col - 1];
			if(cell->color) {
				break;
			}
		}
		pos = FIELD_X + CELL_W * col + fist(side->ofs);
		if((game.cell_pos <= pos) ||
		   (game.cell_pos <= 0 - CELL_W)) { /* s[XʊOɑ݂đs\̎ԂȂ悤 */
			cell = &side->field[row][col];
			memset(cell, 0, sizeof(CELL));
			cell->color = game.cell_color;
			game.taco_stat = 0;
		}
		break;

	case TACO_STAT_THROW_RI:
		game.taco_cnt++; /* p^[\Ԃ̃JE^ */
		game.cell_pos += CELL_SPD;
		side = &game.side[1];
		row = game.cell_row;
		for(col = 0; col < FIELD_COLS - 1; col++) {
			cell = &side->field[row][col + 1];
			if(cell->color) {
				break;
			}
		}
		pos = FIELD_X + CELL_W * col + fist(side->ofs);
		if((game.cell_pos >= pos) ||
		   (game.cell_pos >= DISP_X)) { /* s[XʊOɑ݂đs\̎ԂȂ悤 */
			cell = &side->field[row][col];
			memset(cell, 0, sizeof(CELL));
			cell->color = game.cell_color;
			game.taco_stat = 0;
		}
		break;
	}
}

void
taco_action()
{
	/* 𐅕ړ܂B */
	taco_action_move_x();

	/* 𐂒ړ܂B */
	taco_action_move_y();

	/* z݁AȀs܂B */
	taco_action_cell();
}

/****************************************************************************
 *	ink_gen
 ****************************************************************************/

void
ink_gen()
{
	INK* ink;
	int i;
	int x;
	int y;

	/* 󂫃GgT܂B */
	for(i = 0; i < MAX_INK; i++) {
		ink = &game.ink[i];
		if(!ink->pat) {
			break;
		}
	}
	if(i == MAX_INK) {
		return; /* 󂫃Gg */
	}

	/* ̍W擾܂B */
	x = game.taco_pos;
	y = FIELD_Y + CELL_H * game.taco_row + game.taco_ofs;

	/* W肵܂B */
	ink->x = fld(x);
	ink->y = fld(y);

	/* 肵܂B */
	ink->dir = (fixed)RND16_RANGE(game.seed, -(int)PI, (int)PI);

	/* x肵܂B */
	ink->spd = (fixed)RND16_RANGE(game.seed, (int)fld(1/**/), (int)fld(3/**/));

	/* p^[܂B */
	ink->pat = (fixed)1;
}

/****************************************************************************
 *	ink_disp
 ****************************************************************************/

void
ink_disp()
{
	INK* ink;
	int i;
	int x;
	int y;
	int pat;
	int sprno;

	for(i = 0; i < MAX_INK; i++) {
		ink = &game.ink[i];
		if(!ink->pat) {
			continue;
		}

		x = fist(ink->x);
		y = fist(ink->y);
		pat = fist(ink->pat);
		sprno = SPR_INK0 + pat;
		sprite_draw(x, y, sprno, DRW_NOMAL);
	}
}

/****************************************************************************
 *	ink_action
 ****************************************************************************/

void
ink_action()
{
	INK* ink;
	int i;
	fixed vx;
	fixed vy;

	for(i = 0; i < MAX_INK; i++) {
		ink = &game.ink[i];
		if(!ink->pat) {
			continue;
		}

		/* ړ܂B */
		vx = fmul(fcos(ink->dir), ink->spd);
		vy = fmul(fsin(ink->dir), ink->spd);
		ink->x = fadd(ink->x, vx);
		ink->y = fadd(ink->y, vy);

		/* ܂B */
		ink->spd = fsub(ink->spd, fld(0.1/**/));
		if(ficom(ink->spd, <, 0)) {
			ink->spd = fild(0);
		}

		/* p^[ω܂B */
		ink->pat = fadd(ink->pat, fld(0.5/**/));
		if(ficom(ink->pat, >=, 15)) {
			memset(ink, 0, sizeof(INK)); /*  */
			continue;
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
awa_gen(int i_side, int col, int row)
{
	SIDE* side = &game.side[i_side];
	//
	AWA* awa;
	int i;
	int x;
	int y;

	/* 󂫃GgT܂B */
	for(i = 0; i < MAX_AWA; i++) {
		awa = &game.awa[i];
		if(!awa->spd) {
			break;
		}
	}
	if(i == MAX_AWA) {
		return; /* 󂫃Gg */
	}

	/* Z̍W擾܂B */
	x = FIELD_X + CELL_W * col + fist(side->ofs);
	y = FIELD_Y + CELL_H * row;

	/* ȀoW肵܂B */
	x += RND16_RANGE(game.seed, 0, CELL_W);
	y += RND16_RANGE(game.seed, 0, CELL_H);
	awa->x = fld(x);
	awa->y = fld(y);

	/* F肵܂B */
	awa->color = RND16(game.seed) & 1; /* 0() or 1() */

	/* ㏸x̏l肵܂B */
	awa->spd = (fixed)RND16_RANGE(game.seed, (int)fld(0.1/**/), (int)fld(0.5/**/));
	if(!awa->color) {
		/* 0()1()ϓ{̏xƂ܂B */
		awa->spd = fimul(awa->spd, 2);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
awa_disp()
{
	AWA* awa;
	int i;
	int x;
	int y;

	for(i = 0; i < MAX_AWA; i++) {
		awa = &game.awa[i];
		if(!awa->spd) {
			continue;
		}

		x = fist(awa->x);
		y = fist(awa->y);
		render_point(&render, x, y, awa->color);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
awa_action()
{
	AWA* awa;
	int i;

	for(i = 0; i < MAX_AWA; i++) {
		awa = &game.awa[i];
		if(!awa->spd) {
			continue;
		}

		/* ړ܂B */
		awa->y = fsub(awa->y, awa->spd);
		if(ficom(awa->y, <, 0)) {
			memset(awa, 0, sizeof(AWA)); /*  */
			continue;
		}

		/* ܂B */
		awa->spd = fadd(awa->spd, fld(0.02/**/));
		if(fcom(awa->spd, >, fld(1.0/**/))) {
			awa->spd = fld(1.0/**/);
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _LEVEL_TBL {
	int height;
	fixed field_spd;
} LEVEL_TBL;

static const LEVEL_TBL level_tbl[] = {
{0,fld(0.000)},{3,fld(0.050)},{3,fld(0.058)},{3,fld(0.068)},{3,fld(0.079)},{3,fld(0.093)},{3,fld(0.108)},{3,fld(0.126)},{3,fld(0.147)},{3,fld(0.171)},	/*  0` 9 (0͎g܂) */
{4,fld(0.050)},{4,fld(0.058)},{4,fld(0.068)},{4,fld(0.079)},{4,fld(0.093)},{4,fld(0.108)},{4,fld(0.126)},{4,fld(0.147)},{4,fld(0.171)},{4,fld(0.200)},	/* 10`19 */
{5,fld(0.050)},{5,fld(0.058)},{5,fld(0.068)},{5,fld(0.079)},{5,fld(0.093)},{5,fld(0.108)},{5,fld(0.126)},{5,fld(0.147)},{5,fld(0.171)},{5,fld(0.200)},	/* 20`29 */
{6,fld(0.050)},{6,fld(0.058)},{6,fld(0.068)},{6,fld(0.079)},{6,fld(0.093)},{6,fld(0.108)},{6,fld(0.126)},{6,fld(0.147)},{6,fld(0.171)},{6,fld(0.200)},	/* 30`39 */
{7,fld(0.050)},{7,fld(0.058)},{7,fld(0.068)},{7,fld(0.079)},{7,fld(0.093)},{7,fld(0.108)},{7,fld(0.126)},{7,fld(0.147)},{7,fld(0.171)},{7,fld(0.200)},	/* 40`49 */
{8,fld(0.050)},{8,fld(0.058)},{8,fld(0.068)},{8,fld(0.079)},{8,fld(0.093)},{8,fld(0.108)},{8,fld(0.126)},{8,fld(0.147)},{8,fld(0.171)},{8,fld(0.200)},	/* 50`59 */
{9,fld(0.050)},{9,fld(0.058)},{9,fld(0.068)},{9,fld(0.079)},{9,fld(0.093)},{9,fld(0.108)},{9,fld(0.126)},{9,fld(0.147)},{9,fld(0.171)},{9,fld(0.200)},	/* 60`69 */
{9,fld(0.200)},{9,fld(0.211)},{9,fld(0.223)},{9,fld(0.236)},{9,fld(0.250)},{9,fld(0.264)},{9,fld(0.279)},{9,fld(0.295)},{9,fld(0.312)},{9,fld(0.330)},	/* 70`79 */
{9,fld(0.348)},{9,fld(0.368)},{9,fld(0.389)},{9,fld(0.412)},{9,fld(0.435)},{9,fld(0.460)},{9,fld(0.486)},{9,fld(0.514)},{9,fld(0.543)},{9,fld(0.574)},	/* 80`89 */
{9,fld(0.607)},{9,fld(0.642)},{9,fld(0.678)},{9,fld(0.717)},{9,fld(0.758)},{9,fld(0.801)},{9,fld(0.847)},{9,fld(0.895)},{9,fld(0.946)},{9,fld(1.000)},	/* 90`99 */
};

int
get_height()
{
	int i = game.level;

	if(i > ARRAY_SIZE(level_tbl) - 1) {
		i = ARRAY_SIZE(level_tbl) - 1;
	}

	return level_tbl[i].height;
}

fixed
get_field_spd()
{
	int i = game.level;

	if(i > ARRAY_SIZE(level_tbl) - 1) {
		i = ARRAY_SIZE(level_tbl) - 1;
	}

	return level_tbl[i].field_spd;
}
